/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.tables.records.VCoreStudyFormRecord;

import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class VCoreStudyForm extends TableImpl<VCoreStudyFormRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.v_core_study_form</code>
     */
    public static final VCoreStudyForm V_CORE_STUDY_FORM = new VCoreStudyForm();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VCoreStudyFormRecord> getRecordType() {
        return VCoreStudyFormRecord.class;
    }

    /**
     * The column <code>common_dd.v_core_study_form.key_element</code>.
     */
    public final TableField<VCoreStudyFormRecord, Integer> KEY_ELEMENT = createField(DSL.name("key_element"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_core_study_form.key_parent_element</code>.
     */
    public final TableField<VCoreStudyFormRecord, Integer> KEY_PARENT_ELEMENT = createField(DSL.name("key_parent_element"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_core_study_form.key_element_type</code>.
     */
    public final TableField<VCoreStudyFormRecord, Integer> KEY_ELEMENT_TYPE = createField(DSL.name("key_element_type"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_core_study_form.dn</code>.
     */
    public final TableField<VCoreStudyFormRecord, String> DN = createField(DSL.name("dn"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_core_study_form.order_nr</code>.
     */
    public final TableField<VCoreStudyFormRecord, Integer> ORDER_NR = createField(DSL.name("order_nr"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_core_study_form.short_name</code>.
     */
    public final TableField<VCoreStudyFormRecord, String> SHORT_NAME = createField(DSL.name("short_name"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_core_study_form.is_public</code>.
     */
    public final TableField<VCoreStudyFormRecord, Integer> IS_PUBLIC = createField(DSL.name("is_public"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_core_study_form.hier_lang</code>.
     */
    public final TableField<VCoreStudyFormRecord, String> HIER_LANG = createField(DSL.name("hier_lang"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_core_study_form.stage</code>.
     */
    public final TableField<VCoreStudyFormRecord, Integer> STAGE = createField(DSL.name("stage"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_core_study_form.tree</code>.
     */
    public final TableField<VCoreStudyFormRecord, String> TREE = createField(DSL.name("tree"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_core_study_form.study_element</code>.
     */
    public final TableField<VCoreStudyFormRecord, Integer> STUDY_ELEMENT = createField(DSL.name("study_element"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_core_study_form.study_id</code>.
     */
    public final TableField<VCoreStudyFormRecord, Integer> STUDY_ID = createField(DSL.name("study_id"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_core_study_form.study_name</code>.
     */
    public final TableField<VCoreStudyFormRecord, String> STUDY_NAME = createField(DSL.name("study_name"), SQLDataType.CLOB, this, "");

    private VCoreStudyForm(Name alias, Table<VCoreStudyFormRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VCoreStudyForm(Name alias, Table<VCoreStudyFormRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
        create view "v_core_study_form" as  SELECT f.key_element,
         f.key_parent_element,
         f.key_element_type,
         f.dn,
         f.order_nr,
         f.short_name,
         f.is_public,
         f.hier_lang,
         f.stage,
         t.tree,
         s.study_element,
         s.study_id,
         s.study_name
        FROM ((common_dd.v_core_form f
          LEFT JOIN common_dd.v_core_study s ON ((s.key_element = f.key_element)))
          LEFT JOIN common_dd.v_core_element_tree t ON ((t.key_element = f.key_element)));
        """), where);
    }

    /**
     * Create an aliased <code>common_dd.v_core_study_form</code> table
     * reference
     */
    public VCoreStudyForm(String alias) {
        this(DSL.name(alias), V_CORE_STUDY_FORM);
    }

    /**
     * Create an aliased <code>common_dd.v_core_study_form</code> table
     * reference
     */
    public VCoreStudyForm(Name alias) {
        this(alias, V_CORE_STUDY_FORM);
    }

    /**
     * Create a <code>common_dd.v_core_study_form</code> table reference
     */
    public VCoreStudyForm() {
        this(DSL.name("v_core_study_form"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public VCoreStudyForm as(String alias) {
        return new VCoreStudyForm(DSL.name(alias), this);
    }

    @Override
    public VCoreStudyForm as(Name alias) {
        return new VCoreStudyForm(alias, this);
    }

    @Override
    public VCoreStudyForm as(Table<?> alias) {
        return new VCoreStudyForm(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreStudyForm rename(String name) {
        return new VCoreStudyForm(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreStudyForm rename(Name name) {
        return new VCoreStudyForm(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreStudyForm rename(Table<?> name) {
        return new VCoreStudyForm(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreStudyForm where(Condition condition) {
        return new VCoreStudyForm(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreStudyForm where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreStudyForm where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreStudyForm where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreStudyForm where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreStudyForm where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreStudyForm where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreStudyForm where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreStudyForm whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreStudyForm whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
